{* Copyright 2013 SWITCH *}
{extends file="plain.tpl"}
{block name="head"}
<link href="css/mobileproxy.css" rel="stylesheet" type="text/css" />
{/block}
{block name="menubar"}
<li class="right txt">{$user}</li>
{/block}
{block name="main"}
	<h1>{$h1}</h1>
	<p>On this page all your Devices registered with University Apps are listed. You can revoke any of them by clicking the <em>revoke</em> Link beneath.</p>
	{if isset($flash.info)}
		<p class="flashinfo">{$flash.info}</p>
	{/if}
	{if $logins}
		<table id="logins">
			<tr>
				<th class="wide">App Name</th>
				<th class="wide">Device</th>
				<th class="wide">Requested</th>
				<th class="wide">Expires</th>
				<th class="revoke">Revoke</th>
			</tr>
		{foreach from=$logins item=login}
			<tr>
				<td>{$login.app}</td>
				<td>{$login.device|default:'unknown'}</td>
				<td>{$login.requested|date_format:"%d.%m.%y %T"}</td>
				<td>{$login.expires|date_format:"%d.%m.%y %T"}</td>
				<td class="revoke"><a href='{$smarty.server.REQUEST_URI}/revoke/{$login.sessionId}'>Revoke</a></td>
			</tr>
		{/foreach}
		</table>
	{/if}
{/block}
