<?php
/*
 * Quick implementation of JSend http://labs.omniti.com/labs/jsend
 * @author latzer
 */

class JSend{
	public $status;

	public function setStatus($status){
		switch($status){
		case "success":
		case "fail":
			$this->data = null;
			break;
		case "error":
			$this->message = null;
			break;
		default:
			throw new Exception("Invalid status");
		}
		$this->status = $status;
		return $this;
	}

	public function setData($data){
		$this->data = $data;
		return $this;
	}

	public function setMessage($message){
		$this->message = $message;
		return $this;
	}

	public function setCode($code){
		$this->code = $code;
		return $this;
	}

	public function toJson(){
		//might add validation here
		return json_encode($this);
	}

	public function __toString(){
		return $this->toJson();
	}
}
